//==============================================================
// Copyright (C) Intel Corporation
//
// SPDX-License-Identifier: MIT
// =============================================================
#ifndef SAMPLES_UTILS_H_
#define SAMPLES_UTILS_H_
#include <iostream>
#include <pti/pti_view.h>

namespace samples_utils {
void dump_record(pti_view_record_kernel* record) {
    if (NULL==record) return;
    
    std::cout << "Ze Kernel Start Time: " 
              << record->_start_timestamp << " ns" << '\n';
    std::cout << "Ze Kernel End Time: " 
              << record->_end_timestamp << " ns" << '\n';
    std::cout << "Kernel Queue Handle: "
              << record->_queue_handle << '\n';
    std::cout << "Kernel Device Handle: "
              << record->_device_handle << '\n';
    std::cout << "Kernel Id : " << std::dec
              << record->_kernel_id << '\n';
    std::cout << "Kernel Thread Id : " << std::dec
              << record->_thread_id << '\n';
}

void dump_record(pti_view_record_memory_copy* record) {
    if (NULL==record) return;

    std::cout << "Memory Op: "
        << record->_name << '\n';
    std::cout << "Memory Op Start Time: " << std::dec
        << record->_start_timestamp << " ns" << '\n';
    std::cout << "Memory Op End Time: " << std::dec
        << record->_end_timestamp << " ns" << '\n';
    std::cout << "Memory Op Queue Handle: "
            << record->_queue_handle << '\n';
    std::cout << "Memory Op Device Handle: "
            << record->_device_handle << '\n';
    std::cout << "Memory Op CommandList Context Handle: "
            << record->_context_handle << '\n';
    std::cout << "Memory Op Id : " << std::dec
            << record->_mem_op_id << '\n';
    std::cout << "Memory Op Thread Id : " << std::dec
	    << record->_thread_id << '\n';
}

void dump_record(pti_view_record_memory_fill* record) {
    if (NULL==record) return;

    std::cout << "Memory Op: "
        << record->_name << '\n';
    std::cout << "Memory Op Start Time: " << std::dec
        << record->_start_timestamp << " ns" << '\n';
    std::cout << "Memory Op End Time: " << std::dec
        << record->_end_timestamp << " ns" << '\n';
    std::cout << "Memory Op Queue Handle: "
            << record->_queue_handle << '\n';
    std::cout << "Memory Op Device Handle: "
            << record->_device_handle << '\n';
    std::cout << "Memory Op Id : " << std::dec
            << record->_mem_op_id << '\n';
    std::cout << "Memory Op Thread Id : " << std::dec
            << record->_thread_id << '\n';
}

}
#endif
